package flash.text {
	
	
	/**
	 * @externs
	 * The FontStyle class provides values for the TextRenderer class.
	 */
	final public class FontStyle {
		
		/**
		 * Defines the bold style of a font for the `fontStyle` parameter
		 * in the `setAdvancedAntiAliasingTable()` method. Use the syntax
		 * `FontStyle.BOLD`.
		 */
		public static const BOLD:String = "bold";
		
		/**
		 * Defines the italic style of a font for the `fontStyle`
		 * parameter in the `setAdvancedAntiAliasingTable()` method. Use
		 * the syntax `FontStyle.ITALIC`.
		 */
		public static const BOLD_ITALIC:String = "boldItalic";
		
		/**
		 * Defines the italic style of a font for the `fontStyle`
		 * parameter in the `setAdvancedAntiAliasingTable()` method. Use
		 * the syntax `FontStyle.ITALIC`.
		 */
		public static const ITALIC:String = "italic";
		
		/**
		 * Defines the plain style of a font for the `fontStyle` parameter
		 * in the `setAdvancedAntiAliasingTable()` method. Use the syntax
		 * `FontStyle.REGULAR`.
		 */
		public static const REGULAR:String = "regular";
		
	}
	
	
}