declare namespace openfl.display {
	
	/**
	 * The StageDisplayState class provides values for the
	 * `Stage.displayState` property.
	 */
	export enum StageDisplayState {
		
		/**
		 * Specifies that the Stage is in full-screen mode.
		 */
		FULL_SCREEN = "fullScreen",
		
		/**
		 * Specifies that the Stage is in full-screen mode with keyboard interactivity enabled.
		 */
		FULL_SCREEN_INTERACTIVE = "fullScreenInteractive",
		
		/**
		 * Specifies that the Stage is in normal mode.
		 */
		NORMAL = "normal"
		
	}
	
}


export default openfl.display.StageDisplayState;